// srvrdoc.cpp : implementation of the CGIFServerDoc class
//

#include "stdafx.h"
#include "gifserv.h"
														  
#include "srvrdoc.h"
#include "srvritem.h"
#include "srvrview.h"

#include "gifpict.hpp"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

static inline void TESTOUT(LPCSTR msg)
{
	//AfxMessageBox(msg);
}

/////////////////////////////////////////////////////////////////////////////
// CGIFServerDoc

IMPLEMENT_DYNCREATE(CGIFServerDoc, COleServerDoc)

BEGIN_MESSAGE_MAP(CGIFServerDoc, COleServerDoc)
	//{{AFX_MSG_MAP(CGIFServerDoc)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CGIFServerDoc, COleServerDoc)
	//{{AFX_DISPATCH_MAP(CGIFServerDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//      DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGIFServerDoc construction/destruction

CGIFServerDoc::CGIFServerDoc()
{
	TESTOUT("CGIFServerDoc::CGIFServerDoc()");

	// TODO: add one-time construction code here
	pPicture = NULL;

	EnableAutomation();

	AfxOleLockApp();
}

CGIFServerDoc::~CGIFServerDoc()
{
	AfxOleUnlockApp();
}

BOOL CGIFServerDoc::OnNewDocument()
{
	TESTOUT("CGIFServerDoc::OnNewDocument()");

	if (!COleServerDoc::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	
	TRACE("New Document\n");
	ASSERT(pPicture == NULL);

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CGIFServerDoc server implementation

COleServerItem* CGIFServerDoc::OnGetEmbeddedItem()
{
	// OnGetEmbeddedItem is called by the framework to get the COleServerItem
	//  that is associated with the document.  It is only called when necessary.

	TESTOUT("CGIFServerDoc::OnGetEmbeddedItem()");
	CGIFServerItem* pItem = new CGIFServerItem(this);
	ASSERT_VALID(pItem);
	return pItem;
}

/////////////////////////////////////////////////////////////////////////////
void CGIFServerDoc::OnSetItemRects(LPCRECT lpPosRect, LPCRECT lpClipRect)
{
	// Call base class first
	COleServerDoc::OnSetItemRects(lpPosRect, lpClipRect);

	POSITION pos = GetFirstViewPosition();
	CGIFServerView * pView = (CGIFServerView *) GetNextView(pos);
	pView->SetScrollInfo();
}


/////////////////////////////////////////////////////////////////////////////
// CGIFServerDoc serialization

void CGIFServerDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
		TRACE("Storing serial document\n");
		TESTOUT("CGIFServerDoc::Serialize(storing)");
	}
	else
	{
		// TODO: add loading code here
		TRACE("Loading serial document\n");

		ASSERT(pPicture == NULL);											   	
		pPicture = new XGIFPicture(*ar.GetFile());
		TESTOUT("CGIFServerDoc::Serialize(loading)");
	}
}

/////////////////////////////////////////////////////////////////////////////
// CGIFServerDoc diagnostics

#ifdef _DEBUG
void CGIFServerDoc::AssertValid() const
{
	COleServerDoc::AssertValid();
}

void CGIFServerDoc::Dump(CDumpContext& dc) const
{
	COleServerDoc::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGIFServerDoc commands

BOOL CGIFServerDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	if (!COleServerDoc::OnOpenDocument(lpszPathName))
		return FALSE;
	
	// TODO: Add your specialized creation code here
	TRACE("Open Document\n");
	
	return TRUE;
}

void CGIFServerDoc::DeleteContents() 
{
	// TODO: Add your specialized code here and/or call the base class
	TRACE("Delete Document Contents\n");

	delete pPicture;
	pPicture = NULL;
		
	COleServerDoc::DeleteContents();
}

CSize CGIFServerDoc::getDocSize() 
{
	if (pPicture != NULL)
	{
		return CSize(pPicture->width(), pPicture->height());
		TESTOUT("CGIFServerDoc::getDocSize() - picture != null");
	}
	else
	{
		return CSize(1, 1);
		TESTOUT("CGIFServerDoc::getDocSize() - picture is null");
	}
}

void CGIFServerDoc::draw(CDC & dc, const RECT & r2) 
{
	if (pPicture != NULL)
	{
		TESTOUT("CGIFServerDoc::draw() - picture != null");
		pPicture->draw(dc, r2);
	}
	else
		TESTOUT("CGIFServerDoc::draw() - picture is null");
}

void CGIFServerDoc::OnEditCopy() 
{
	CGIFServerItem * pItem = GetEmbeddedItem();
	pItem->CopyToClipboard(TRUE);	
}
